<!doctype html>
<html>

<head>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.9.3/Chart.bundle.js"></script>
</head>

<body>
  <div style="width:100%;">
    <canvas id="canvas"></canvas>
  </div>
  <br>
  <input type="file" id="input" accept=".json" multiple/>
  <label for="input">Open either a single or multiple files...</label>
  <script>
    const ctx = document.getElementById('canvas').getContext('2d');
    const input = document.getElementById('input');
    var cfg;
    var metaData;
    
    window.onload = function(event) {
      cfg = {
        type: 'bar',
        data: {
          labels: [],
          datasets: [{
            data: []
          }]
        },
        options: {
          legend: {
            display: false
          }
        }
      };
      window.myLine = new Chart(ctx, cfg);
    }

    input.onchange = function(event) {
      if (event.target.files.length == 0) return;
      var fnames = [];
      for (var i = 0; i < event.target.files.length; ++i) {
        fnames[i] = event.target.files[i].name;
      }
      getMetaDataFromFname(fnames);
      readFiles(event.target.files);
    }

    function readFiles(list){
      jsonData = [];
      var promises = [];
      for (var file of list) {
        var filePromise = new Promise(resolve => {
          var reader = new FileReader();
          reader.readAsText(file);
          reader.onload = () => resolve(reader.result);
        });
        promises.push(filePromise);
      }
      Promise.all(promises).then(fileContents => {
        var rawDataSets = [];
        for (var i = 0; i < fileContents.length; ++i) {
          rawDataSets[i] = JSON.parse(fileContents[i]);
        }
        generateChart(rawDataSets);
      });
    }

    function generateChart(rawDataSets) {
      cfg.data.labels = [];
      cfg.data.datasets = [];

      if (!rawDataSets[1]) {	// only one input dataset
        var displayData = {};
        displayData.data = [];
        displayData.backgroundColor = [];
        var rawData = rawDataSets[0];

        var best = {
          index: 0,
          value: rawData[0][0].time
        }
        for (var i = 0; i < rawData[0].length; ++i) {
          cfg.data.labels[i] = '('+rawData[0][i].block_size_x+','+rawData[0][i].block_size_y+')';
          var cur = rawData[0][i].time;
          if (cur < best.value) {
            best.value = cur;
            best.index = i;
          }
          if (cur < Math.pow(10,38)) {
            displayData.data[i] = cur;
          } else {
            displayData.data[i] = 0;
          }
          displayData.backgroundColor[i] = "tomato";
        }
        displayData.backgroundColor[best.index] = "steelblue";

        cfg.options.scales = {
          xAxes: [{
            ticks: {
              padding: 6
            },
            gridLines: {
              drawOnChartArea: false,
              drawTicks: false
            },
            scaleLabel: {
              display: true,
              labelString: 'block dimensions as (x,y)'
            }
          }],
          yAxes: [{
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: false
        }
        var label = "Matmul C=A*B with ";
        label += "A=<" + metaData[0].a + ">[" + metaData[0].m + "x" + metaData[0].k + "], ";
        label += "B=<" + metaData[0].b + ">[" + metaData[0].k + "x" + metaData[0].n + "], ";
        label += "tvs=" + metaData[0].t;
        cfg.options.title = {
          display: true,
          text: label
        }
        cfg.data.datasets[0] = displayData;
      }
      else {	// multiple input datasets
        var displayData1 = {};
        var displayData2 = {};
        var displayData3 = {};
        var displayData4 = {};
        displayData1.data = [];
        displayData2.data = [];
        displayData3.data = [];
        displayData4.data = [];
        displayData1.backgroundColor = "tomato";
        displayData2.backgroundColor = "seagreen";
        displayData3.backgroundColor = "teal";
        displayData4.backgroundColor = "steelblue";
        for (var i = 0; i < rawDataSets.length; ++i) {
          var rawData = rawDataSets[i];

          var bestOfSet = rawData[0][0].time;
          for (var j = 0; j < rawData[0].length; ++j) {
            var cur = rawData[0][j].time;
            if (cur < bestOfSet) {
              bestOfSet = cur;
            }						
          }

          var correctIndex = getTypeDiagramIndex(metaData[i].a, metaData[i].b, metaData[i].t);

          if (bestOfSet > Math.pow(10,38)) bestOfSet = 0;
          var m = parseInt(metaData[i].m)
          switch (m) {
            case 32: displayData1.data[correctIndex] = bestOfSet; break;
            case 64: displayData2.data[correctIndex] = bestOfSet; break;
            case 128: displayData3.data[correctIndex] = bestOfSet; break;
            case 256: displayData4.data[correctIndex] = bestOfSet; break;
            default: console.log("Error: could not assign correct dataset to: " + m);
          }
        }

        for (var i = 0; i < 20; ++i) {
          cfg.data.labels[i] = getLabelOfIndex(i);
        }

        cfg.options.scales = {
          xAxes: [{
            ticks: {
              lineHeight: 1,
              fontSize: 12
            },
            scaleLabel: {
              display: true,
              labelString: "Datatypes as '<type of A, type of B> tvs'"
            }
          }],
          yAxes: [{
            type: 'logarithmic',
            scaleLabel: {
              display: true,
              labelString: 'avg runtime [ms]'
            },
            ticks: {
              //min: 0
            }
          }]
        }
        cfg.options.legend = {
          display: true
        }
        cfg.options.title = {
          display: true,
          text: "Comparison of best performing configurations"
        }
        displayData1.label = "32x256x128";
        displayData2.label = "64x512x256";
        displayData3.label = "128x1024x512";
        displayData4.label = "256x2048x1024";
        cfg.data.datasets[0] = displayData1;
        cfg.data.datasets[1] = displayData2;
        cfg.data.datasets[2] = displayData3;
        cfg.data.datasets[3] = displayData4;
      }
      window.myLine.update();
    }

    function getMetaDataFromFname(fnames) {
      metaData = [];
      for (var i = 0; i < fnames.length; ++i) {
        var fields = fnames[i].split('_');
        var m = fields[1].substring(1);
        var k = fields[2].substring(1);
        var n = fields[3].substring(1);
        var a = fields[4].substring(1);
        a = a.replace('1','f').replace('2','d').replace('3','i').replace('4','t');
        var b = fields[5].substring(1);
        b = b.replace('1','f').replace('2','d').replace('3','i').replace('4','t');
        var t = fields[6].substring(1);
        metaData[i] = {
          m: m,
          k: k,
          n: n,
          a: a,
          b: b,
          t: t
        }
      }
    }

    function getSize(typeA, typeB, M, K, N, tvs) {
      var size = 0;
      size += getTypeSize(typeA, tvs)*M*K;
      size += getTypeSize(typeB, tvs)*K*N;
      return size;
    }

    function getTypeSize(type, tvs) {
      var size = 0;
      switch (type) {
        case 'f': size = 4; break;
        case 'd': size = 8; break;
        case 'if': size = 8; break;
        case 'id': size = 16; break;
        case 'tf': size = 4+tvs*4; break;
        case 'td': size = 8+tvs*8; break;
        case 'itf': size = 2*(4+tvs*4); break;
        case 'itd': size = 2*(8+tvs*8); break;
        default: break;
      }
      return size;
    }

    function getTypeDiagramIndex(typeA, typeB, tvs) {
      var op = typeA+typeB+tvs;
      switch (op) {
        case 'ff1': return 0;
        case 'dd1': return 1;
        case 'fif1': return 2;
        case 'did1': return 3;
        case 'tftf1': return 4;
        case 'tdtd1': return 5;
        case 'tftf4': return 6;
        case 'tdtd4': return 7;
        case 'tftf16': return 8;
        case 'tdtd16': return 9;
        case 'tftf64': return 10;
        case 'tdtd64': return 11;
        case 'tfitf1': return 12;
        case 'tditd1': return 13;
        case 'tfitf4': return 14;
        case 'tditd4': return 15;
        case 'tfitf16': return 16;
        case 'tditd16': return 17;
        case 'tfitf64': return 18;
        case 'tditd64': return 19;
        default: return -1;
      }
    }

    function getLabelOfIndex(index) {
      switch (index) {
        case 0: return '<f,f>';
        case 1: return '<d,d>';
        case 2: return '<f,if>';
        case 3: return '<d,id>';
        case 4: return '<tf,tf> 1';
        case 5: return '<td,td> 1';
        case 6: return '<tf,tf> 4';
        case 7: return '<td,td> 4';
        case 8: return '<tf,tf> 16';
        case 9: return '<td,td> 16';
        case 10: return '<tf,tf> 64';
        case 11: return '<td,td> 64';
        case 12: return '<tf,itf> 1';
        case 13: return '<td,itd> 1';
        case 14: return '<tf,itf> 4';
        case 15: return '<td,itd> 4';
        case 16: return '<tf,itf> 16';
        case 17: return '<td,itd> 16';
        case 18: return '<tf,itf> 64';
        case 19: return '<td,itd> 64';
        default: return -1;
      }
    }
  </script>
</body>

</html>
